<?php
// This will occur when the comment is posted
function theme_pre_comment_post( $incoming_comment ) {
	// convert everything in a comment to display literally
	$incoming_comment['comment_content'] = htmlspecialchars($incoming_comment['comment_content']);
	return( $incoming_comment );
}
add_filter( 'preprocess_comment', 'theme_pre_comment_post', '', 1);

function theme_comment_text($text){
	global $comment;
	$text = preg_replace('/(\r?\n){2}/', "<br/><br/>", $text);
	$text = preg_replace('/(\r?\n)/', "<br/>", $text);
	$comment->comment_content = $text;
	//return json_encode($text);
}
add_filter('comment_text', 'theme_comment_text');


function SearchFilter($query) {
	if ($query->is_search) {
		$query->set('post_type', 'post');
	}
	return $query;
}

add_filter('pre_get_posts', 'SearchFilter');


register_sidebar(
	array(
		'id'            => 'home-sidebar-a',
		'name'          => 'home-sidebar-a',
		'description'   => '',
		'before_widget' => '<div id="%1$s" class="%2$s widget">',
		'after_widget'  => '</div><!-- /.widget -->',
		'before_title'  => '<h2 class="title">',
		'after_title'   => '</h2>',
	)
);
/*
register_sidebar(
	array(
		'id'            => 'list-sidebar-a',
		'name'          => 'list-sidebar-a',
		'description'   => '',
		'before_widget' => '<div id="%1$s" class="%2$s widget">',
		'after_widget'  => '</div><!-- /.widget -->',
		'before_title'  => '<h2 class="title">',
		'after_title'   => '</h2>',
	)
);
register_sidebar(
	array(
		'id'            => 'single-sidebar-a',
		'name'          => 'single-sidebar-a',
		'description'   => '',
		'before_widget' => '<div id="%1$s" class="%2$s widget">',
		'after_widget'  => '</div><!-- /.widget -->',
		'before_title'  => '<h2 class="title">',
		'after_title'   => '</h2>',
	)
);
*/

function widget_itheme_meta() {
?>
	<div class="widget meta">
		<h2 class="title">Meta</h2>
		<ul>
			<?php wp_register('<li class="site_admin">','</li>'); ?>
			<li class="rss"><a href="<?php bloginfo('rss2_url'); ?>">Entries (RSS)</a></li>
			<li class="rss"><a href="<?php bloginfo('comments_rss2_url'); ?>">Comments (RSS)</a></li>
			<li class="login"><?php wp_loginout(); ?></li>
		</ul>
	</div><!-- /.widget -->
<?php
}
if ( function_exists('register_sidebar_widget') ){
    register_sidebar_widget(__('Meta'), 'widget_itheme_meta');
}



function theme_get_header($param = array()){
	include('header.php');
}


function theme_echo_pagenavi(){
	global $wp_query, $posts_per_page, $wpdb, $paged;
	$maxButtonCount = 9; //显示的最多链接数目

	$current_page = $paged;

	if (!is_single()) {
		if(!is_category() && !is_tag()) {
			preg_match('#FROM\s(.*)\sORDER BY#siU', $wp_query->request, $matches);		
		} else {
			preg_match('#FROM\s(.*)\sGROUP BY#siU', $wp_query->request, $matches);		
		}
		$fromwhere = $matches[1];
		$numposts = $wpdb->get_var("SELECT COUNT(DISTINCT ID) FROM $fromwhere");

		$max_page = ceil($numposts /$posts_per_page);
		if(empty($current_page)) {
			$current_page = 1;
		}

		$start = max(1, $current_page - intval($maxButtonCount/2));
		$end = min($start + $maxButtonCount - 1, $max_page);
		$start = max(1, $end - $maxButtonCount + 1);

		if($current_page <= 1){
			echo "<span>|&lt;</span>";
			echo "<span>&lt;&lt;</span>";
		}else{
			echo '<a href="'.get_pagenum_link().'"><span>|&lt;</span></a>';
			echo '<a href="'.get_pagenum_link($current_page-1).'"><span>&lt;&lt;</span></a>';
		}
		for($i=$start; $i<=$end; $i++){
			if($i == $current_page) {
				echo "<span class=\"page_num on\">$i</span>";
			} else {
				echo '<a href="'.get_pagenum_link($i).'"><span class="page_num">'.$i.'</span></a>';
			}
		}
		if($current_page >= $max_page){
			echo "<span>&gt;&gt;</span>";
			echo "<span>&gt;|</span> ";
		}else{
			echo '<a href="'.get_pagenum_link($current_page+1).'"><span>&gt;&gt;</span></a>';
			echo '<a href="'.get_pagenum_link($max_page).'"><span>&gt;|</span></a>';
		}

		echo " {$current_page}/{$max_page} Pages, {$numposts} Results.";
	}
}


